% Sistemas Realimentados
% Por: Sergio Castao
% Prof. Julio Elias Normey Rico
%% Dinamica de um tanque de Nvel
clc
clear all
close all
%Variaveis do tanque
k1=0.05;k2=0.015;g=10;
A=0.5;
a1=0.0:0.1:1;   %Avertura da valvula de entrada
a2=0:0.1:1;     %Avertura da valvula de Saida
k=1;

A1o=0.6; %Avertura da Valvula no Pto de Equilibrio
A2o=0.5; %Avertura da valvula de saida no equilibrio

%Encuentro o Pto de Equilibrio do Tanque
Ho=(k1^2*A1o^2)/(k2^2*A2o^2*2*g);

%Grafico nao linear do comportamento do Nvel manipulando a valvula de
%entrada e deixando a valvula de sada constante e viceverza
for i=1:11   
       hA1(i)=(k1^2*a1(i)^2)/(k2^2*A2o^2*2*g);
       hA2(i)=(k1^2*A1o^2)/(k2^2*a2(i)^2*2*g);
       k=k+1;
end
figure
t=0:0.1:1;
subplot(2,1,1);
plot(t,hA1),grid
axis([0 1 0 1]);
title('Variao em valvula de entrada a1');
ylabel('Altura (h)');
xlabel('Abertura da Valvula a1');
subplot(2,1,2);
plot(t,hA2),grid
axis([0 1 0 1]);
title('Variao em valvula de entrada a2');
ylabel('Altura (h)');
xlabel('Abertura da Valvula a2');

%% Processo de Simulao
tsim=400;       %tempo de simulao
tA1=100;         %Tempo em que a variao de a1 acontece
tA2=250;        %Tempo em que a variao de a2 acontece

dA1=0.5;       %Variao em a1
dA2=0.05;       %Variao em a2
%Simulao
sim('tanque1');
%Grafica dos resultados
figure
subplot(3,1,1);
plot(t,rY(:,1),t,rY(:,3)),grid
title('Nvel do Tanque');
ylabel('Altura (h)');
xlabel('Tempo (s)');
legend('No Linear','Linear');

subplot(3,1,2);
plot(t,rY(:,2)),grid
title('Abertura em a1');
ylabel('% a1');
xlabel('Tempo (s)');

subplot(3,1,3);
plot(t,rY(:,4)),grid
title('Abertura em a2');
ylabel('% a2');
xlabel('Tempo (s)');
clc

%% Projeto dos Controladores
%% Processo de Simulao

%Controle Proporcional
tsim=120;       %tempo de simulao

ref= [1 0.6 0.2 0.9 0.9]'; %Referencias

per=[0.5 0.85]'; %Perturbacoes
tper=90;

Kc=100;
%Simulao
sim('tanque_Kc');
%Grafica dos resultados
figure
subplot(2,1,1);
plot(t,rY(:,1),t,rY(:,2)),grid
title('Controle Kc=100');
ylabel('Altura (h)');
xlabel('Tempo (s)');
subplot(2,1,2);
plot(t,rY(:,3)),grid
ylabel('Abertura A2');
xlabel('Tempo (s)');

%Controle PI Cancelamento
%Por cancelamento se faz Ti igual ao polo do modelo linear

Tau=A/((k2*A2o*sqrt(2*g))/(2*sqrt(Ho)));
Kp=k1/((k2*A2o*sqrt(2*g))/(2*sqrt(Ho)));

%Por cancelamento s devo dar o tempo desejado da MF (Tr)
Tr=Tau/5;

Ti=Tau;
Kc=Ti/(Kp*Tr);

tsim=500;       %tempo de simulao

ref= [0.8 0.6 0.7 0.65 0.65]'; %Referencias

per=[0.5 0.80]'; %Perturbacoes
tper=350;

%Simulao
sim('tanque_PI_Can');
%Grafica dos resultados
figure
subplot(3,1,1);
plot(t,rY(:,1),t,rY(:,2)),grid
title('Controle PI Cancelamento');
ylabel('Altura (h)');
xlabel('Tempo (s)');
subplot(3,1,2);
plot(t,rY(:,4)),grid
ylabel('Controle');
xlabel('Tempo (s)')
subplot(3,1,3);
plot(t,rY(:,3)),grid
ylabel('Abertura A2');
xlabel('Tempo (s)')

%Por cancelamento se evidencia que a rejeicao de perturbacao  muito lenta

C=tf(Kc*[Ti 1],[Ti 0]);
P=tf(0.1,[1 0.0375]);
Q=tf(-0.12,[1 0.0375]);

YR=minreal((C*P)/(1+C*P));
YQ=minreal((Q)/(1+C*P));
figure
subplot(2,2,1)
pzmap(YR);
title('DPZ_R');
subplot(2,2,2)
rlocus(YR);
subplot(2,2,3)
pzmap(YQ);
title('DPZ_Q');
subplot(2,2,4)
rlocus(YQ);

%Controle por Alocacao de polos
%% Calculo do controlador (Alocao de Polos)

TsMA=(Tau*3)/5;       %Tempo de acomodao MA (Sistema de Primera Ordem)
ep=1;                             %Coeficente de amortecimento
Wn=3/(ep*TsMA);                     %Frequncia Natural
Sd=[-ep*Wn+1i*Wn*sqrt(1-ep^2), -ep*Wn-1i*Wn*sqrt(1-ep^2)]; %Alocao de Polos
Pds=poly(Sd);

Kc=(Pds(2)*Tau-1)/Kp;        %Calculo de Kc
Ti=(Kp*Kc)/(Pds(3)*Tau);     %Calculo de ti

%Simulao
sim('tanque_PI_Can');
%Grafica dos resultados
figure
subplot(3,1,1);
plot(t,rY(:,1),t,rY(:,2)),grid
title('Controle PI Polos Reais Iguais');
ylabel('Altura (h)');
xlabel('Tempo (s)');
subplot(3,1,2);
plot(t,rY(:,4)),grid
ylabel('Controle');
xlabel('Tempo (s)')
subplot(3,1,3);
plot(t,rY(:,3)),grid
ylabel('Abertura A2');
xlabel('Tempo (s)')

C=tf(Kc*[Ti 1],[Ti 0]);
P=tf(0.1,[1 0.0375]);
Q=tf(-0.12,[1 0.0375]);

YR=minreal((C*P)/(1+C*P));
YQ=minreal((Q)/(1+C*P));
figure
subplot(2,2,1)
pzmap(YR);
title('DPZ_R');
subplot(2,2,2)
rlocus(YR);
subplot(2,2,3)
pzmap(YQ);
title('DPZ_Q');
subplot(2,2,4)
rlocus(YQ);
